#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: generate_ost_list.pl, v2.0.0-1 Wed 19 Oct 2011 11:42:48 AM EDT  mstauber Exp $
# Copyright 2006-2011 Stauber Multimedie Design. All rights reserved.

# This constructor / handler parses the list of available OS templates and stores them
# into CODB.

$whatami = "constructor";

use CCE;
my $cce = new CCE;
my $conf = '/var/lib/cobalt';

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Debugging switch:
$DEBUG = "0";

# Location of the vzlist-dump:
$vzlistdump = '/tmp/vserver-list';

# Location of vserver config files (directory - with trailing slash):
$vzcfgdir = '/etc/sysconfig/vz-scripts/';

# We are starting sane:
$bad_info_detected = '0';

# CCE'ize existing OS-Templates:
&ostemplates;

# CCE'ize example VPS config files:
&sampleconfigs;

$cce->bye('SUCCESS');
exit(0);

##
# Subs:
##

# Pull the existing OS Templates into CCE:
sub ostemplates {
    if (!-d "/vz/template") {
	system("/bin/mkdir /vz/template");
    }
    if (!-d "/vz/template/cache") {
        system("/bin/mkdir /vz/template/cache");
    }
    if (!-d "/vz/template/ISO") {
        system("/bin/mkdir /vz/template/ISO");
    }

    # Find all previous VserverOStemplates entries and destroy them:
    @oldsamples = $cce->findx('VserverOStemplates', { 'template_type' => 'openvz'} );
    for $entry (@oldsamples) {
        ($ok) = $cce->destroy($entry);
    }

    # Handle OpenVZ OS templates:
    system ("rm -f /tmp/ostemplates");
    system("ls -k1 /vz/template/cache/*.tar.gz |sed 's/\.tar\.gz//'g | cut -d / -f 5 > /tmp/ostemplates");

    # Does the dump file exist?
    $cfile = "/tmp/ostemplates";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    # Populate CCE:
            ($ok) = $cce->create('VserverOStemplates', {
            	    'OSTnusol' => 'nusol',
            	    'OStemplateShortName' => $line,
            	    'OStemplateFullName' => $line . '.tar.gz',
            	    'template_type' => 'openvz'
            	    });
        }
    }
    system ("rm -f /tmp/ostemplates");

    # Handle locally stored ISO images:
    system ("rm -f /tmp/ostemplates");
    system("ls -k1 /vz/template/ISO/* | cut -d / -f 5 > /tmp/ostemplates");

    # Does the dump file exist?
    $cfile = "/tmp/ostemplates";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

	# Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
	    
	    $OStemplateFullName = $line;	    
	    $line = `echo $line | sed -e s/\.iso//g -e s/\.ISO//g -e s/\.img//g -e s/\.IMG//g`;
	    chomp $line;

	    ($found) = $cce->findx('VserverOStemplates', { 'template_type' => 'iso', 'OStemplateFullName' => $OStemplateFullName } );
	    if (!$found) {
		# Populate CCE:
		($ok) = $cce->create('VserverOStemplates', {
            	    'OSTnusol' => 'nusol',
            	    'OStemplateShortName' => $line,
            	    'OStemplateFullName' => $OStemplateFullName,
            	    'template_type' => 'iso'
		 });
	    }
	}
    }
    system ("rm -f /tmp/ostemplates");

}

# Pull the existing sample VPS config files into CCE:
sub sampleconfigs {
    system ("rm -f /tmp/sampleconf");
    system("ls -k1 $vzcfgdir*.conf-sample | cut -d \/ -f5 |sed 's/ve-//'g | sed 's/.conf-sample//'g > /tmp/sampleconf");

    # Does the config file exist?
    $cfile = "/tmp/sampleconf";
    if (-e $cfile) {
        open(CFILE,"$cfile") || die("Could not find $cfile. $!");

        # Find all previous VserverConfigSamples entries and destroy them:
        @oldsamples = $cce->findx('VserverConfigSamples', { 'nusol' => 'nusol' });
        for $entry (@oldsamples) {
            ($ok) = $cce->destroy($entry);
        }

        # Parse the dumpfile:
        while ($line = <CFILE>) {
            chomp($line);
            next if $line =~ /^\s*$/; # skip blank lines
            
            # Populate CCE:
            ($ok) = $cce->create('VserverConfigSamples', {
                    'nusol' => 'nusol',
                    'ConfigShortName' => $line,
                    'ConfigFullName' => 've-' . $line . '.conf-sample'
                    });
        }
    }
    system ("rm -f /tmp/sampleconf");
}

$cce->bye('SUCCESS');
exit(0);

