#!/usr/bin/perl -I/usr/sausalito/perl
# $Id: kvm_support.pl, v2.0.0-1 Wed 19 Oct 2011 11:42:48 AM EDT mstauber Exp $
# Copyright 2006-2011 Stauber Multimedie Design. All rights reserved.

# This constructor / handler to find out if this hardware will support KVM.
# It then stores this info in 'kvm_support' in 'VserverMasterNode'.

$whatami = "constructor";

use CCE;
my $cce = new CCE;
use Sys::Virt;

if ($whatami eq "handler") {
    $cce->connectfd();
}
else {
    $cce->connectuds();
}

# Do the deeds:
&main;

$cce->bye('SUCCESS');
exit(0);

##
# Subs:
##

# Do the deeds:
sub main {

    # Get number of available CPU cores:
    $con = Sys::Virt->new(address => "", readonly => 1);
    $ninfo = $con->get_node_info;
    $max_node_cpu_cores = $ninfo->{'cores'};

    system("/sbin/chkconfig messagebus on");
    system("/sbin/chkconfig avahi-daemon on");
    system("/sbin/chkconfig libvirtd on");

    $kvm_support = "0";
    $info = `egrep '^flags.*(vmx|svm)' /proc/cpuinfo`;
    if (length($info) > "0") {
	$kvm_support = "1";
    }
    @oids = $cce->find('VserverMasterNode');
    ($ok) = $cce->set($oids[0], '',{ 'kvm_support_hw' => $kvm_support, 'node_cores' => $max_node_cpu_cores });

    # Small hotfix for eth0 having br0's details in CODB:
    @oids = $cce->find('Network', {'device' => 'eth0'});
    ($ok) = $cce->set($oids[0], '',{ 'ipaddr' => "", 'netmask' => "" });
}

$cce->bye('SUCCESS');
exit(0);

